/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2025 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "tim.h"
#include "gpio.h"
#include "PCD8544.h"
/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
   uint16_t counter=0;
	
	unsigned char const Nokia_bmp[504] = {
	 0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x00,0x00,0x80,0x80,0x40,0x40,0x40,0x80,0x80,0xC0,0xC0,0x40,0xC0,0xA0,
	 0xE0,0xC0,0xE0,0xE0,0xF0,0xF0,0xF8,0xF8,0xF8,0xFC,0xFC,0xFE,0xEE,0xF4,0xF0,0xF0,0x70,0x30,0x00,0x80,0x00,0x00,0x80,0x00,0x0C,0x9C,0x1C,0x38,0xB8,0x38,
	 0x38,0xB8,0xF8,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF8,0xF8,0xF8,0xF8,0x88,0x20,0x8A,0x20,0x08,0x22,
	 0x08,0x00,0x0A,0x00,0x00,0x02,0x80,0x71,0xBA,0xDA,0xFD,0xDD,0xED,0xDE,0xEE,0xF7,0xFF,0xFB,0xFD,0xFD,0xFE,0xFF,0x7F,0x3F,0x1F,0x9F,0x3F,0x7F,0x6F,0x0F,
	 0xAF,0x1F,0xBF,0x3E,0x3C,0x7A,0x78,0x70,0x22,0x88,0xA0,0x2A,0x80,0x08,0x62,0xE0,0xE0,0xF2,0xF0,0x58,0xDA,0xF8,0xFC,0x92,0xFE,0xFF,0xFF,0xD3,0xFF,0xFD,
	 0xF3,0xE1,0xF0,0xF9,0x7F,0xBF,0x3F,0x8F,0x2F,0x4F,0xAF,0x0F,0x4F,0xA7,0x0F,0xAF,0x87,0x2F,0x82,0x80,0x20,0xC0,0x80,0x80,0x50,0x40,0xC4,0xD0,0xA0,0xE8,
	 0xE4,0xEA,0xFF,0xFB,0xFD,0xFF,0xFF,0xFF,0xFF,0xFF,0xEF,0x4F,0x27,0x53,0xA8,0x54,0x29,0x4A,0xB5,0x82,0xAC,0xA1,0x8A,0xB6,0x50,0x4D,0x32,0xA4,0x4A,0xB4,
	 0xA9,0x4A,0x52,0xB4,0xAA,0x45,0xA8,0xDA,0x22,0xAC,0xD2,0x2A,0x52,0xA8,0x52,0x4C,0xB0,0xAD,0x43,0x5B,0xB3,0x45,0xA8,0x5B,0xA3,0xAB,0x55,0xA8,0x52,0x54,
	 0xA9,0x56,0xA8,0x45,0xBA,0xA4,0x49,0x5A,0xA2,0x54,0xAA,0x52,0xFE,0xFF,0xFF,0xFE,0xFD,0xFF,0xFF,0xFF,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	 0xFF,0xFF,0xFF,0x7F,0xFF,0xFE,0xBF,0x7F,0xBF,0xBF,0xFF,0xDF,0xBF,0x5F,0xDF,0x7F,0xDF,0x7F,0xDF,0xAF,0x7F,0xEE,0x8E,0xF1,0x6E,0x99,0xF7,0x6A,0xDD,0xB2,
	 0x6E,0xD5,0x7A,0xD7,0xAC,0x75,0xDB,0x6D,0xD5,0x7A,0xD7,0xAC,0x7B,0xE5,0xDE,0xA9,0x77,0xDA,0xB5,0xEE,0x59,0xB6,0xEB,0xDD,0xB6,0x69,0xD6,0xBF,0xE8,0x55,
	 0xEF,0xB9,0xD6,0xED,0xB5,0x5B,0xAB,0xFF,0xFD,0xF7,0xFF,0x01,0x01,0x01,0x01,0xE1,0xC1,0x81,0x03,0x05,0x0F,0x1D,0x2F,0x7E,0x01,0x00,0x01,0x01,0xFF,0xFE,
   0x03,0x01,0x01,0x00,0xF1,0xF0,0xF1,0x71,0xF1,0xF1,0xB1,0xF1,0x01,0x01,0x01,0x03,0xFE,0xFF,0x01,0x01,0x01,0x01,0xBE,0x1B,0x0D,0x07,0x03,0x41,0xE1,0xF1,
	 0xF9,0x6D,0xFF,0xFF,0x00,0x01,0x01,0x01,0xFF,0xFF,0xEB,0x3E,0x0D,0x03,0x01,0x41,0x71,0x70,0x41,0x01,0x03,0x0E,0x3B,0xEF,0xFE,0xFB,0xEE,0x7D,0xF7,0xFF,
	 0xFF,0xFF,0xFF,0xFE,0xFF,0xF0,0xF0,0xF0,0xF0,0xFF,0xFF,0xFF,0xFF,0xFE,0xFC,0xF8,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xFF,0xFF,0xF8,0xF0,0xF0,0xF0,0xF1,0xF1,
	 0xF1,0xF1,0xF1,0xF1,0xF1,0xF1,0xF0,0xF0,0xF0,0xF8,0xFF,0xFF,0xF0,0xF0,0xF0,0xF0,0xFF,0xFF,0xFE,0xFC,0xF8,0xF0,0xF0,0xF1,0xF3,0xF7,0xFF,0xFF,0xF0,0xF0,
	 0xF0,0xF0,0xFF,0xF3,0xF0,0xF0,0xF0,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xF0,0xF0,0xF0,0xF3,0xFF,0xFF,0xFF,0xFF,0xFF
};
	
  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_TIM10_Init();
	HAL_TIM_Base_Start(&htim10);
  /* USER CODE BEGIN 2 */
  PCD8544_init();
  PCD8544_clear_screen(WHITE); 
	PCD8544_backlight_state(ON);
  PCD8544_print_image(Nokia_bmp);
  HAL_Delay(2000);
  PCD8544_backlight_state(OFF);
  HAL_Delay(2000);
  PCD8544_clear_screen(WHITE); 
	PCD8544_backlight_state(ON);
	PCD8544_clear_screen(WHITE);	
  PCD8544_set_contrast(0x33);
  PCD8544_print_string(10, 2, "COUNTER", WHITE);
  /* USER CODE END 2 */
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */
    for(counter=0; counter<=9999; counter++) {
			  print_int(14, 4, counter, WHITE);
			  HAL_Delay(1000);
		  }	
		
    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 12;
  RCC_OscInitStruct.PLL.PLLN = 96;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_3) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
